#include <stdio.h>
/*
 * 			Copyright 1993, 1994 by AT&T
 * 
 * 			 All Rights Reserved
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of AT&T not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.
 * 
 * AT&T DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * AT&T BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 * 
 * AT&T's dontation of this software does not imply a licence granted for
 * patents nor transfer of ownership of any patents which may inadvertently
 * be implemented in this code.
 * 
 */

#include <X11/Xlib.h>

#ifndef TRUE
#define	TRUE	1
#define	FALSE	0
#endif

void
main(argc, argv)
int argc;
char **argv;
{
    Display *display;
    int screen;
    Window rootwindow;
    int width, height;
    Pixmap p;
    Colormap colormap;

    /*
     * Open up the display.
     */
    if ((display = XOpenDisplay(NULL)) == NULL)
    {
	fprintf (stderr, "%s: Can't open display.\n");
	exit (1);
    }
    screen = DefaultScreen (display);
    rootwindow = RootWindow (display, screen);
	
    if (argc == 2)
    {
	p = LoadPixmap (display, screen,
			argv[1], FALSE,
			&colormap, &width, &height);

	XSetWindowBackgroundPixmap (display, rootwindow, p);
    }
    else
    {
	XSetWindowBackgroundPixmap (display, rootwindow,
				    (Pixmap) NULL);
    }

    XClearWindow (display, rootwindow);
    XSync (display, 0);
}
