static char TMnetCrtImg_c[] = "<%W%	%D% %T%>";
/*
 * 			Copyright 1993, 1994 by AT&T
 * 
 * 			 All Rights Reserved
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of AT&T not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.
 * 
 * AT&T DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * AT&T BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 * 
 * AT&T's dontation of this software does not imply a licence granted for
 * patents nor transfer of ownership of any patents which may inadvertently
 * be implemented in this code.
 * 
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>

#include "C_P_args.h"

C_PROTOS_BEGIN_EXTERN

extern XImage *
netCreateImage C_P_ARGS((Display *display, int out_width, int out_height));

C_PROTOS_END_EXTERN

/*
 * create an image that matches the display
 */
XImage *
netCreateImage (display, out_width, out_height)
Display *display;
int out_width;
int out_height;
{
    XImage *out;
    int screen = DefaultScreen (display);
    int depth = DefaultDepth (display, screen);

    out = XCreateImage (display, DefaultVisual (display, screen),
			depth,
			(depth > 1) ? ZPixmap : XYPixmap,
			0,	/* offset */
			(char *) NULL,
			out_width, out_height,
			8,	/* bitmap quantum */
			0);

    if (out == (XImage *) NULL)
	XtError ("Cannot allocate image space.");

    out -> data = (char *) XtMalloc (out -> bytes_per_line *
				     out -> height);
    return out;
}
