static char TMxtent_wdgts_c[] = "<%W%	%D% %T%>";
/*
 * 			Copyright 1993, 1994 by AT&T
 * 
 * 			 All Rights Reserved
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of AT&T not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.
 * 
 * AT&T DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * AT&T BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 * 
 * AT&T's dontation of this software does not imply a licence granted for
 * patents nor transfer of ownership of any patents which may inadvertently
 * be implemented in this code.
 * 
 */

#include <stdio.h>
#include <X11/Intrinsic.h>
#include "xtent.h"
#include "xtent_wdgts.h"

/*
 * supported widgets - add widget name and class pointer for each widget
 */
#ifdef ATHENA
XtentWidgetClassName XtentWidgetClassNames[] =
{
    { "applicationShell",	&applicationShellWidgetClass	},
    { "asciiSink",		&asciiSinkObjectClass		},
    { "asciiSrc",		&asciiSrcObjectClass		},
    { "asciiText",		&asciiTextWidgetClass		},
    { "box",			&boxWidgetClass			},
    { "clock",			&clockWidgetClass		},
    { "command",		&commandWidgetClass		},
    { "composite",		&compositeWidgetClass		},
    { "constraint",		&constraintWidgetClass		},
    { "dialog",			&dialogWidgetClass		},
    { "form",			&formWidgetClass		},
    { "grip",			&gripWidgetClass		},
    { "label",			&labelWidgetClass		},
    { "list",			&listWidgetClass		},
    { "logo",			&logoWidgetClass		},
    { "menuButton",		&menuButtonWidgetClass		},
    { "object",			&objectClass			},
    { "overrideShell",		&overrideShellWidgetClass	},
    { "paned",			&panedWidgetClass		},

#if XT_REVISION > 4
    { "panner",			&pannerWidgetClass		},
    { "porthole",		&portholeWidgetClass		},
    { "repeater",		&repeaterWidgetClass		},
    { "tree",			&treeWidgetClass		},
#endif

    { "scrollbar",		&scrollbarWidgetClass		},
    { "shell",			&shellWidgetClass		},
    { "simpleMenu",		&simpleMenuWidgetClass		},
    { "simple",			&simpleWidgetClass		},
    { "smeBSB",			&smeBSBObjectClass		},
    { "smeLine",		&smeLineObjectClass		},
    { "sme",			&smeObjectClass			},
    { "stripChart",		&stripChartWidgetClass		},
    { "text",			&textWidgetClass		},
    { "toggle",			&toggleWidgetClass		},
    { "topLevelShell",		&topLevelShellWidgetClass	},
    { "transientShell",		&transientShellWidgetClass	},
    { "viewport",		&viewportWidgetClass		},
    { "wmShell",		&wmShellWidgetClass		},

    { "net",			&netResourcesWidgetClass	},
    { "smraster",		&XwsmrasterWidgetClass		},

    { (char *) NULL,		NULL				}
};
#endif /* ATHENA */

#ifdef MOTIF
XtentWidgetClassName XtentWidgetClassNames[] =
{
    { "applicationShell",	&applicationShellWidgetClass	},
    { "overrideShell",		&overrideShellWidgetClass	},
    { "shell",			&shellWidgetClass		},
    { "topLevelShell",		&topLevelShellWidgetClass	},
    { "transientShell",		&transientShellWidgetClass	},
    { "wmShell",		&wmShellWidgetClass		},
    { "xmArrowButton",		&xmArrowButtonWidgetClass	},
    { "xmArrowButtonGadget",	&xmArrowButtonGadgetClass	},
    { "xmBulletinBoard",	&xmBulletinBoardWidgetClass	},
    { "xmCascadeButton",	&xmCascadeButtonWidgetClass	},
    { "xmCascadeButtonGadget",	&xmCascadeButtonGadgetClass	},
    { "xmCommand",		&xmCommandWidgetClass		},
    { "xmDialogShell",		&xmDialogShellWidgetClass	},
    { "xmDragIcon",		&xmDragIconObjectClass		},
    { "xmDrawingArea",		&xmDrawingAreaWidgetClass	},
    { "xmDrawnButton",		&xmDrawnButtonWidgetClass	},
    { "xmFileSelectionBox",	&xmFileSelectionBoxWidgetClass	},
    { "xmForm",			&xmFormWidgetClass		},
    { "xmFrame",		&xmFrameWidgetClass		},
    { "xmLabel",		&xmLabelWidgetClass		},
    { "xmLabelGadget",		&xmLabelGadgetClass		},
    { "xmList",			&xmListWidgetClass		},
    { "xmMainWindow",		&xmMainWindowWidgetClass	},
    { "xmMenuShell",		&xmMenuShellWidgetClass		},
    { "xmMessageBox",		&xmMessageBoxWidgetClass	},
    { "xmPanedWindow",		&xmPanedWindowWidgetClass	},
    { "xmPushButton",		&xmPushButtonWidgetClass	},
    { "xmPushButtonGadget",	&xmPushButtonGadgetClass	},
    { "xmRowColumn",		&xmRowColumnWidgetClass		},
    { "xmScale",		&xmScaleWidgetClass		},
    { "xmScrollBar",		&xmScrollBarWidgetClass		},
    { "xmScrolledWindow",	&xmScrolledWindowWidgetClass	},
    { "xmSelectionBox",		&xmSelectionBoxWidgetClass	},
    { "xmSeparator",		&xmSeparatorWidgetClass		},
    { "xmSeparatorGadget",	&xmSeparatorGadgetClass		},
    { "xmText",			&xmTextWidgetClass		},
    { "xmTextField",		&xmTextFieldWidgetClass		},
    { "xmToggleButton",		&xmToggleButtonWidgetClass	},
    { "xmToggleButtonGadget",	&xmToggleButtonGadgetClass	},

    { "net",			&netResourcesWidgetClass	},
    { "smraster",		&XwsmrasterWidgetClass		},

    { (char *) NULL,		NULL				}
};
#endif /* MOTIF */

#ifdef OPENLOOK
#include <Xol/OpenLookP.h>  /* RAD - contains OL_VERSION */

XtentWidgetClassName XtentWidgetClassNames[] =
{
    { "abbrevMenuButton",	&abbrevMenuButtonWidgetClass	  },
    { "bulletinBoard",		&bulletinBoardWidgetClass	  },
    { "caption",		&captionWidgetClass		  },
    { "checkBox",		&checkBoxWidgetClass		  },
    { "controlArea",		&controlAreaWidgetClass		  },
#ifndef OLD_OPENLOOK
    { "drawArea",               &drawAreaWidgetClass              },
    { "dropTarget",             &dropTargetWidgetClass            },
#endif /* OLD_OPENLOOK */
    { "exclusives",		&exclusivesWidgetClass		  },
    { "flatCheckBox",		&flatCheckBoxWidgetClass	  },
    { "flatExclusives",		&flatExclusivesWidgetClass	  },
    { "flatNonexclusives",	&flatNonexclusivesWidgetClass	  },
    { "footerPanel",		&footerPanelWidgetClass		  },
    { "form",			&formWidgetClass		  },
    { "gauge",			&gaugeWidgetClass		  },
    { "help",                   &helpWidgetClass                  },
    { "mag",                    &magWidgetClass                   },
    { "menuShell",		&menuShellWidgetClass		  },
    { "menubutton",		&menuButtonWidgetClass		  },
    { "menuButton",		&menuButtonWidgetClass		  },
    { "nonexclusives",		&nonexclusivesWidgetClass	  },
    { "noticeShell",		&noticeShellWidgetClass		  },
    { "oblongButton",		&oblongButtonWidgetClass	  },
    { "oblongButtonGadget",	&oblongButtonGadgetClass	  },
    { "popupWindowShell",	&popupWindowShellWidgetClass	  },
    { "rectButton",		&rectButtonWidgetClass		  },
    { "rubberTile",             &rubberTileWidgetClass            },
    { "scrolledWindow",		&scrolledWindowWidgetClass	  },
    { "scrollbar",		&scrollbarWidgetClass		  },
    { "scrollingList",		&scrollingListWidgetClass	  },
    { "slider",			&sliderWidgetClass		  },
    { "staticText",		&staticTextWidgetClass		  },
    { "stub",			&stubWidgetClass		  },
#if OL_VERSION <= 2  /* RAD - pre-solaris OpenWindows */
    { "text",			&textWidgetClass		  },
#endif /* OL_VERSION <= 2 */
    { "textEdit",		&textEditWidgetClass		  },
    { "textField",		&textFieldWidgetClass		  },

    { "applicationShell",	&applicationShellWidgetClass	},
    { "overrideShell",		&overrideShellWidgetClass	  },
    { "shell",			&shellWidgetClass		  },
    { "topLevelShell",		&topLevelShellWidgetClass	  },
    { "transientShell",		&transientShellWidgetClass	  },

    { "menubuttonGadget",	&menuButtonGadgetClass		  },

    { "net",			&netResourcesWidgetClass	  },
    { "smraster",		&XwsmrasterWidgetClass		  },

    { (char *) NULL,		NULL				  }
};
#endif /* OPENLOOK */

#ifdef HP_WIDGETS
XtentWidgetClassName XtentWidgetClassNames[] =
{
    { "arrow",          &XwarrowWidgetClass       },
    { "bulletin",       &XwbulletinWidgetClass    },
    { "cascade",        &XwcascadeWidgetClass     },
    { "form",           &XwformWidgetClass        },
    { "imageEdit",      &XwimageEditWidgetClass   },
    { "list",           &XwlistWidgetClass        },
    { "menuSep",        &XwmenuSepWidgetClass     },
    { "menubutton",     &XwmenubuttonWidgetClass  },
    { "menumgr",        &XwmenumgrWidgetClass     },
    { "overrideShell",  &overrideShellWidgetClass },
    { "panel",          &XwpanelWidgetClass       },
    { "popupmgr",       &XwpopupmgrWidgetClass    },
    { "pushButton",     &XwpushButtonWidgetClass  },
    { "rowCol",         &XwrowColWidgetClass      },
    { "sash",           &XwsashWidgetClass        },
    { "scrollbar",      &XwscrollbarWidgetClass   },
    { "shell",          &shellWidgetClass         },
    { "sraster",        &XwsrasterWidgetClass     },
    { "statictext",     &XwstatictextWidgetClass  },
    { "swindow",        &XwswindowWidgetClass     },
    { "textedit",       &XwtexteditWidgetClass    },
    { "titlebar",       &XwtitlebarWidgetClass    },
    { "toggle",         &XwtoggleWidgetClass      },
    { "topLevelShell",  &topLevelShellWidgetClass },
    { "transientShell", &transientShellWidgetClass},
    { "vPaned",         &XwvPanedWidgetClass      },
    { "valuator",       &XwvaluatorWidgetClass    },

    { "net",		&netResourcesWidgetClass  },
    { "smraster",       &XwsmrasterWidgetClass    },

    { (char *) NULL,    NULL,                     }
};
#endif /* HP_WIDGETS */
